
var PrintUtils = {

  showPageSetup: function ()
  {
    var didOK = false;
    try {
      var printSettings = this.getPrintSettings();

      var webBrowserPrint = null;
      if (_content) {
        var ifreq = _content.QueryInterface(Components.interfaces.nsIInterfaceRequestor);
        webBrowserPrint = ifreq.getInterface(Components.interfaces.nsIWebBrowserPrint);
      }

      var PRINTPROMPTSVC = Components.classes["@mozilla.org/embedcomp/printingprompt-service;1"]
                                     .getService(Components.interfaces.nsIPrintingPromptService);
      didOK = PRINTPROMPTSVC.showPageSetup(window, printSettings, null);

      if (didOK) {
        if (webBrowserPrint) {
          var PREF = Components.classes["@mozilla.org/preferences-service;1"]
                               .getService(Components.interfaces.nsIPrefBranch);
          var isGlobal = PREF.getBoolPref("print.use_global_printsettings", false);
          var doSave   = PREF.getBoolPref("print.save_print_settings", false);

          if (isGlobal && doSave) {
            var PSSVC = Components.classes["@mozilla.org/gfx/printsettings-service;1"]
                                  .getService(Components.interfaces.nsIPrintSettingsService);
            PSSVC.savePrintSettingsToPrefs(printSettings, false, printSettings.kInitSaveNativeData);
          }
        }
      }
    } catch (e) {
      dump("showPageSetup "+e+"\n");
    }
    return didOK;
  },

  print: function ()
  {
    try {
      var ifreq = _content.QueryInterface(Components.interfaces.nsIInterfaceRequestor);
      var webBrowserPrint = ifreq.getInterface(Components.interfaces.nsIWebBrowserPrint);     
      if (webBrowserPrint) {
        var printSettings = this.getPrintSettings();
        webBrowserPrint.print(printSettings, null);
      }
    } catch (e) {
      // Pressing cancel is expressed as an NS_ERROR_ABORT return value,
      // causing an exception to be thrown which we catch here.
      // Unfortunately this will also consume helpful failures, so add a
      // dump("print: "+e+"\n"); // if you need to debug
    }
  },


  ////////////////////////////////////////
  // "private" methods. Don't use them. //
  ////////////////////////////////////////

  setPrinterDefaultsForSelectedPrinter: function (aPRINTSVC, aPrintSettings)
  {
    if (!aPrintSettings.printerName)
      aPrintSettings.printerName = aPRINTSVC.defaultPrinterName;

    // First get any defaults from the printer 
    aPRINTSVC.initPrintSettingsFromPrinter(aPrintSettings.printerName, aPrintSettings);
    // now augment them with any values from last time
    aPRINTSVC.initPrintSettingsFromPrefs(aPrintSettings, true,  aPrintSettings.kInitSaveAll);
  },

  getPrintSettings: function ()
  {
    var printSettings;
    var PREF = Components.classes["@mozilla.org/preferences-service;1"]
                         .getService(Components.interfaces.nsIPrefBranch);
    try {
      var isGlobal = PREF.getBoolPref("print.use_global_printsettings", false);

      var PRINTSVC = Components.classes["@mozilla.org/gfx/printsettings-service;1"]
                               .getService(Components.interfaces.nsIPrintSettingsService);
      if (isGlobal) {
        printSettings = PRINTSVC.globalPrintSettings;
        this.setPrinterDefaultsForSelectedPrinter(PRINTSVC, printSettings);
      } else
        printSettings = PRINTSVC.newPrintSettings;
    } catch (e) {
      dump("getPrintSettings: "+e+"\n");
    }
    return printSettings;
  }
}
